package net.bjoerks.httpgetpostrequest_assertxmlreq;
import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.webkit.WebView;
import android.widget.TextView;
import android.widget.Toast;

import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.Reader;
import java.net.HttpURLConnection;
import java.net.URL;

import org.apache.http.Header;
import org.apache.http.protocol.HTTP;

public class HttpGetPostRequest_AssertXmlReq extends Activity {
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);

        this.findViewById(R.id.buttonGetSide).setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                onClick_buttonGetSide(v);
            }
        });

        this.findViewById(R.id.buttonSoapSubtract).setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                onClick_buttonSoapSubtract(v);
            }
        });

        this.findViewById(R.id.buttonSoapPersoner).setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                onClick_buttonSoapPersoner(v);
            }
        });

        this.findViewById(R.id.buttonSoapPersonerMedPostnr).setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                onClick_buttonSoapPersonerMedPostnr(v);
            }
        });


    }

    private void onClick_buttonGetSide(View v) {
        try {

            TextView textView1 = (TextView)this.findViewById(R.id.textView1);
            String response = DataHelper.getHttpGetRequest("http://bjoerks.net/http/", "text/html");
            textView1.setText(response);
        }
        catch (Exception e){
            Toast.makeText(this, "Fejl: "+e.getMessage(), Toast.LENGTH_LONG);
        }
    }

    private void onClick_buttonSoapSubtract(View v) {
        TextView textView1 = (TextView)this.findViewById(R.id.textView1);
        String response = doSoapSubtractRequest(5,8);
        textView1.setText(response);
        int b = response.indexOf("<SubtractResult>");
        int e = response.indexOf("</SubtractResult>");
        if (b<e) {
            response = response.substring(b+"<SubtractResult>".length(), e);
            textView1.append("\n\n\n\nResultatet var: <"+response+">");
        }
    }

    private void onClick_buttonSoapPersoner(View v) {
        TextView textView1 = (TextView)this.findViewById(R.id.textView1);
        String response = doSoapAsmxCall_GetAllePersoner();
        textView1.setText(response);
    }

    private void onClick_buttonSoapPersonerMedPostnr(View v) {
        TextView textView1 = (TextView)this.findViewById(R.id.textView1);
        String response = doSoapWcfCall_GetAllePersonerMedPostnr(5200, 5210, false);
        textView1.setText(response);
    }

    public String doSoapSubtractRequest(int a, int b) {
        try {

            String soapPostReqText = DataHelper.readAssetFileIntoString(this, "soapAsmxCall_Subtract.xml");

            soapPostReqText = soapPostReqText.replace("@param_a", ""+a);
            soapPostReqText = soapPostReqText.replace("@param_b", ""+b);

            return DataHelper.getHttpPostRequest("http://webservicedemo.bjoerks.net/RegneWebService.asmx",
                    "text/xml; charset=utf-8",
                    "http://tempuri.org/Subtract",
                    soapPostReqText);
        }
        catch (Exception e){
            Toast.makeText(this, "Fejl: "+e.getMessage(), Toast.LENGTH_LONG);
            return "Error: returmsg=<"+e.getMessage()+">\n";
        }
    }

    public String doSoapAsmxCall_GetAllePersoner() {
        try {

            String soapPostReqText = DataHelper.readAssetFileIntoString(this, "SoapAsmxCall_GetAllePersoner.xml");

            return DataHelper.getHttpPostRequest("http://webservicedemo.bjoerks.net/PersonWebService.asmx",
                    "text/xml; charset=utf-8",
                    "http://tempuri.org/GetAllePersoner",
                    soapPostReqText);
        }
        catch (Exception e){
            Toast.makeText(this, "Fejl: "+e.getMessage(), Toast.LENGTH_LONG);
            return "Error: returmsg=<"+e.getMessage()+">\n";
        }
    }


    public String doSoapWcfCall_GetAllePersonerMedPostnr(int fraPostnr, int tilPostnr, boolean orderEfternavnFornavn) {
        try {

            String soapPostReqText = DataHelper.readAssetFileIntoString(this, "SoapWcfCall_GetAllePersonerMedPostnr.xml");

            soapPostReqText = soapPostReqText.replace("@param_fraPostnr", ""+fraPostnr);
            soapPostReqText = soapPostReqText.replace("@param_tilPostnr", ""+tilPostnr);
            if (orderEfternavnFornavn)
                soapPostReqText = soapPostReqText.replace("@param_orderEfternavnFornavn", "true");
            else
                soapPostReqText = soapPostReqText.replace("@param_orderEfternavnFornavn", "false");

            return DataHelper.getHttpPostRequest("http://webservicedemo.bjoerks.net/PersonWcfService.svc/soap",
                    "text/xml; charset=utf-8",
                    "http://tempuri.org/IPersonWcfService/GetAllePersonerMedPostnr",
                    soapPostReqText);
        }
        catch (Exception e){
            Toast.makeText(this, "Fejl: "+e.getMessage(), Toast.LENGTH_LONG);
            return "Error: returmsg=<"+e.getMessage()+">\n";
        }
    }


}